-- SRB2Kart Hitfeed by Snu

-- Yes this is very much Hitfeed
rawset(_G, "hitfeed", true)
local dprint = HF_DPrint	-- oh yeah woo yeah

-- ThinkFrame for the more hacky hitmessages...
addHook("ThinkFrame", do
	for p in players.iterate
		if not (p.mo and p.mo.valid) then continue end
		
		-- hyudoro hack
		if (p.kartstuff[k_stealingtimer] == 16)
			for p2 in players.iterate -- let's find who we're stealing from
				if not (p2.mo and p2.mo.valid) then continue end
				
				if (p2.kartstuff[k_stolentimer] == p.kartstuff[k_stealingtimer]) -- so LOCALLY it's equal
				or (p2.kartstuff[k_stolentimer] == (p.kartstuff[k_stealingtimer]+1)) -- ...but in netgames it's +1??????
					-- no need to do anything else, send hitmessage and break out of the loop
					local s = {{p.name, p.mo.hf_overridenamecolor or p.skincolor}, {skins[p.mo.skin].facemmap, p.skincolor}, p}
					local v = {{p2.name, p2.mo.hf_overridenamecolor or p2.skincolor}, {skins[p2.mo.skin].facemmap, p2.skincolor}, p2}
					HF_SendHitMessage(s, v, "K_HMHYU")
					break
				end
			end
		end
		-- shrink hacks
		if (p.kartstuff[k_itemtype] == KITEM_SHRINK)
			p.hf_hasshrink = true
			if (p.hf_shrinkamount ~= nil and p.kartstuff[k_itemamount] ~= p.hf_shrinkamount)
				-- you have multiple shrink... somehow??? extra hackage
				local s = {{p.name, p.mo.hf_overridenamecolor or p.skincolor}, {skins[p.mo.skin].facemmap, p.skincolor}, p}
				HF_SendHitMessage(s, nil, "K_HMSRK")
			end
			p.hf_shrinkamount = p.kartstuff[k_itemamount]
		else
			if p.hf_hasshrink and (p.pflags & PF_ATTACKDOWN) -- if they had it, check if they used it!
				local s = {{p.name, p.mo.hf_overridenamecolor or p.skincolor}, {skins[p.mo.skin].facemmap, p.skincolor}, p}
				HF_SendHitMessage(s, nil, "K_HMSRK")
			end
			-- reset vars either way
			p.hf_hasshrink, p.hf_shrinkamount = nil, nil
		end
	end
end)

-- PlayerSpin Hit Messages
addHook("PlayerSpin", function(p, inflictor, source)
	if not (source and source.player) then return end
	if not (p.mo and p.mo.valid) then return end	-- without this, we sometimes get an error??? sure
	
	local s = {{source.player.name, source.hf_overridenamecolor or source.player.skincolor}, {skins[source.skin].facemmap, source.player.skincolor}, source.player}
	local v = {{p.name, p.mo.hf_overridenamecolor or p.skincolor}, {skins[p.mo.skin].facemmap, p.skincolor}, p}
	if (s[3] == v[3]) then s = nil end	-- source == victim, remove source
	
	-- allow for icon overrides
	local icon = inflictor.hf_overrideicon or HF_GetIcon_Spin(p, inflictor, source)
	HF_SendHitMessage(s, v, icon)
end)

-- Player Squish Hit Messages
addHook("PlayerSquish", function(p, inflictor, source)
	if not (source and source.player) then return end
	if not (p.mo and p.mo.valid) then return end
	
	local s = {{source.player.name, source.hf_overridenamecolor or source.player.skincolor}, {skins[source.skin].facemmap, source.player.skincolor}, source.player}
	local v = {{p.name, p.mo.hf_overridenamecolor or p.skincolor}, {skins[p.mo.skin].facemmap, p.skincolor}, p}
	if (s[3] == v[3]) then s = nil end	-- source == victim, remove source
	
	-- allow for icon overrides
	local icon = inflictor.hf_overrideicon or HF_GetIcon_Squish(p, inflictor, source)
	HF_SendHitMessage(s, v, HF_GetIcon_Squish(p, inflictor, source))
end)

-- Player Explode Hit Messages
addHook("PlayerExplode", function(p, inflictor, source)
	if not (source and source.player) then return end
	if not (p.mo and p.mo.valid) then return end
	
	local s = {{source.player.name, source.hf_overridenamecolor or source.player.skincolor}, {skins[source.skin].facemmap, source.player.skincolor}, source.player}
	local v = {{p.name, p.mo.hf_overridenamecolor or p.skincolor}, {skins[p.mo.skin].facemmap, p.skincolor}, p}
	if (s[3] == v[3]) then s = nil end	-- source == victim, remove source
	
	-- allow for icon overrides
	local icon = inflictor.hf_overrideicon or HF_GetIcon_Explode(p, inflictor, source)
	HF_SendHitMessage(s, v, icon)
end)

-- special sink MobjDamage
addHook("MobjDamage", function(mo, inflictor, source)
	if not (mo and mo.valid) then return end
	
	if (inflictor and inflictor.type == MT_SINK)
		if (source and source.player) -- paranoia from battle plus sinks
			
			local s = {{source.player.name, source.hf_overridenamecolor or source.player.skincolor}, {skins[source.skin].facemmap, source.player.skincolor}, source.player}
			local v = {{mo.player.name, mo.hf_overridenamecolor or mo.player.skincolor}, {skins[mo.skin].facemmap, mo.player.skincolor}, mo.player}
			if (s[3] == v[3]) then s = nil end	-- source == victim, remove source
			
			-- allow for icon overrides
			local icon = inflictor.hf_overrideicon or "K_HMSNK"
			HF_SendHitMessage(s, v, icon)
		end
	end
end, MT_PLAYER)

-- draw hitmessages
local lastleveltime, fuckreplays = 0, 0 -- hack vars
hud.add(function(v, p, c)
	if not (cv_hf.value) then hf_hitmessages = {} return end -- clear the table, not needed
	if not (#hf_hitmessages) then return end -- we dont have any hitmessages to display!
	
	-- remove hitmessages that would otherwise break the message limit
	local message_limit = (splitscreen > 1) and cv_hf_ml.value/2 or cv_hf_ml.value
	while (#hf_hitmessages > message_limit)
		table.remove(hf_hitmessages, 1) 
	end
	
	-- fuck replays, I just wanna use p.splitscreenindex like a normal person
	if (splitscreen) -- replay splitscreen is dumb
		fuckreplays = $+1
		if (fuckreplays > 1)
			-- dont render more than once in replays
			if (fuckreplays > (splitscreen)) then fuckreplays = 0 end
			return
		end
	end
	
	-- get base y position, check if overrides exist from mods
	local hy = HF_SplitscreenVar(hf_overrides[2] or 9, hf_2_overrides[2] or 100, hf_34_overrides[2] or 9)
	-- get base snapflags, check if overrides exist
	-- TopLeft = 1, Left = 2, BottomLeft = 3, Top = 4, Middle = 5, Bottom = 6, TopRight = 7, Right = 8, BottomRight = 9
	local snapflags = HF_SplitscreenVar(hf_overrides[3] or 1, hf_2_overrides[3] or 5, hf_34_overrides[3] or 4)

	local i = #hf_hitmessages -- set base variables
	-- shift base y position to center depending on snapflags
	if not (snapflags == 1 or snapflags == 4 or snapflags == 7)
		local hy_shift = 14+(14*(#hf_hitmessages-1))
		-- middle flag, divide by 2
		if (snapflags == 2 or snapflags == 5 or snapflags == 8) then hy_shift = $/2 end
		-- now take away hy_shift from the starting y position to snap it correctly
		hy = $-(hy_shift)
	end

	while i
		local hm = hf_hitmessages[i] -- current hitmessage
		
		-- animation handling
		if HF_animIcon[hm[3]]	-- animation for icon exists
			-- {anim_patchnum, anim_timer}
			local frames, tics = HF_animIcon[hm[3]][1], HF_animIcon[hm[3]][2]
			
			if (lastleveltime ~= leveltime) or (paused)	-- interp support
				hm[6][2] = $+1
				if (hm[6][2] > tics)
					hm[6][1] = $+1 -- increment frame count
					if (hm[6][1] > frames)
						hm[6][1] = 1	-- reset frame
					end
					hm[6][2] = 1	-- reset tics
				end
			end
		end
		
		-- transparency handling
		local loctflag = v.localTransFlag()
		local trans_diff = ((V_90TRANS + V_10TRANS) - loctflag)>>V_ALPHASHIFT	-- shift to make it between 0-10

		local fade, fade2, fade3 = loctflag, (trans_diff/2)<<V_ALPHASHIFT, max(2, (trans_diff/5))<<V_ALPHASHIFT
		fade3 = max($, fade)
		local target1, target2, target3 = fade, fade2, fade3
		if hm[4] < 20
			local t = (20 - hm[4])/2
			fade = max(target1, V_10TRANS*t)
			t = $/2
			fade2, fade3 = max(target2, V_50TRANS + V_10TRANS*t), max(target3, max($, fade))
		end
		
		-- table containing each flag set
		local snapFlagSets = {V_SNAPTOTOP|V_SNAPTOLEFT, V_SNAPTOLEFT, V_SNAPTOBOTTOM|V_SNAPTOLEFT, V_SNAPTOTOP, 0, V_SNAPTOBOTTOM, V_SNAPTOTOP|V_SNAPTORIGHT, V_SNAPTORIGHT, V_SNAPTOBOTTOM|V_SNAPTORIGHT}

		-- get base x position, check if overrides exist from mods
		local hx = HF_SplitscreenVar(hf_overrides[1] or 52, hf_2_overrides[1] or 160, hf_34_overrides[1] or 160)
		-- shift base x position to center depending on snapflags
		-- TopLeft = 1, Left = 2, BottomLeft = 3, Top = 4, Middle = 5, Bottom = 6, TopRight = 7, Right = 8, BottomRight = 9
		if (snapflags > 3) -- more than 3, let's do calcs
			local hx_shift = HF_MessageWidth(v, hm)
			-- middle snapflags, divide by 2 to center it
			if (snapflags < 7) then hx_shift = $/2 end
			-- now take away hx_shift from the starting hx position to snap it correctly
			hx = $-(hx_shift)
		end
		
		-- check if the message is relative to consoleplayer/displayplayers
		local p1, p2 = hm[1] and hm[1][3], hm[2] and hm[2][3]
		local r = (HF_IsPlayerRelative(p1) or HF_IsPlayerRelative(p2))
		
		-- HITMESSAGE DRAWING
		
		-- left border
		local bd = (r) and "HL" or "HT"
		if (cv_hf_bd.value) then v.draw(hx, hy, v.cachePatch("K_"..bd.."MSGS"), snapFlagSets[snapflags]|(r and fade3 or fade2), v.getColormap(-1, cv_hf_hc.value)) end
		hx = $+6
		
		-- source
		local hf_drawnsource = false
		if (hm[1]) -- make sure table exists
			-- draw icon
			local hf_drawnicon = false
			if (cv_hf_dm.value != 1)
				local icon = v.cachePatch(hm[1][2][1])
				HF_DrawBackdrop(v, hx, hy, icon.width, snapFlagSets[snapflags], {fade2, fade3}, r)
				hx = $+HF_DrawIcon(v, hx, hy, icon, FRACUNIT, hm[1][2][2], snapFlagSets[snapflags]|fade)
				
				hf_drawnicon = true	-- for potential spacing later
			end
			
			-- draw name
			if (cv_hf_dm.value != 2)
				if (hf_drawnicon)	-- spacing
					hx = $+HF_DrawBackdrop(v, hx, hy, 1, snapFlagSets[snapflags], {fade2, fade3}, r)
				end
				
				local str = hm[1][1][1]
				local hf_strtoolong = false
				if (str:len() > cv_hf_cl.value)
					str = str:sub(1, cv_hf_cl.value)
					hf_strtoolong = true
				end
				HF_DrawBackdrop(v, hx, hy, v.stringWidth(str, V_ALLOWLOWERCASE|V_6WIDTHSPACE, "thin"), snapFlagSets[snapflags], {fade2, fade3}, r)
				hx = $+HF_DrawString(v, hx, hy, str, hm[1][1][2], snapFlagSets[snapflags]|fade)
				if (hf_strtoolong)
					HF_DrawBackdrop(v, hx, hy, v.stringWidth("..", V_ALLOWLOWERCASE|V_6WIDTHSPACE, "thin"), snapFlagSets[snapflags], {fade2, fade3}, r)
					hx = $+HF_DrawString(v, hx, hy, "..", hm[1][1][2], snapFlagSets[snapflags]|fade)
				end
			end
			
			hf_drawnsource = true	-- for potential spacing later
		end
		
		-- icon
		if (hf_drawnsource)	-- spacing
			hx = $+HF_DrawBackdrop(v, hx, hy, 1, snapFlagSets[snapflags], {fade2, fade3}, r)
		end
		local icon = v.cachePatch(HF_animIcon[hm[3]] and (hm[3]..hm[6][1]) or hm[3])
		HF_DrawBackdrop(v, hx, hy, (icon.width*FRACUNIT/2)>>FRACBITS, snapFlagSets[snapflags], {fade2, fade3}, r)
		hx = $+HF_DrawIcon(v, hx, hy, icon, FRACUNIT/2, hm[5], snapFlagSets[snapflags]|fade)
		
		-- victim
		if (hm[2]) -- make sure table actually exists
			-- initial spacing
			hx = $+HF_DrawBackdrop(v, hx, hy, 1, snapFlagSets[snapflags], {fade2, fade3}, r)
			
			-- draw icon
			local hf_drawnicon = false
			if (cv_hf_dm.value != 1)
				local icon = v.cachePatch(hm[2][2][1])
				HF_DrawBackdrop(v, hx, hy, icon.width, snapFlagSets[snapflags], {fade2, fade3}, r)
				hx = $+HF_DrawIcon(v, hx, hy, icon, FRACUNIT, hm[2][2][2], snapFlagSets[snapflags]|fade)
				
				hf_drawnicon = true	-- for potential spacing later
			end
			
			-- draw name
			if (cv_hf_dm.value != 2)
				if (hf_drawnicon)	-- spacing
					hx = $+HF_DrawBackdrop(v, hx, hy, 1, snapFlagSets[snapflags], {fade2, fade3}, r)
				end
				
				local str = hm[2][1][1]
				local hf_strtoolong = false
				if (str:len() > cv_hf_cl.value)
					str = str:sub(1, cv_hf_cl.value)
					hf_strtoolong = true
				end
				HF_DrawBackdrop(v, hx, hy, v.stringWidth(str, V_ALLOWLOWERCASE|V_6WIDTHSPACE, "thin"), snapFlagSets[snapflags], {fade2, fade3}, r)
				hx = $+HF_DrawString(v, hx, hy, str, hm[2][1][2], snapFlagSets[snapflags]|fade)
				if (hf_strtoolong)
					HF_DrawBackdrop(v, hx, hy, v.stringWidth("..", V_ALLOWLOWERCASE|V_6WIDTHSPACE, "thin"), snapFlagSets[snapflags], {fade2, fade3}, r)
					hx = $+HF_DrawString(v, hx, hy, "..", hm[2][1][2], snapFlagSets[snapflags]|fade)
				end
			end
		end
		
		-- right border
		local bd = (r) and "HL" or "HT"
		if (cv_hf_bd.value) then v.draw(hx, hy, v.cachePatch("K_"..bd.."MSGE"), snapFlagSets[snapflags]|(r and fade3 or fade2), v.getColormap(-1, cv_hf_hc.value)) end
		
		-- handle timer for the current message
		if (lastleveltime ~= leveltime) or (paused) -- interp support
			hm[4] = $-1
			if not hm[4]
				table.remove(hf_hitmessages, i)
				i = $-1
				continue
			end
		end
		hy = $+14
		i = $-1
	end
	
	lastleveltime = leveltime
end)

-- reset table for new maps
addHook("MapLoad", function()
	hf_hitmessages = {}
end)